{******************************************

2 points  voir dans ce corrig :

(1) le type numr
(2) la protection du code avec le gestionnaire d'exceptions TRY...EXCEPT..END

*******************************************}

unit UVoiture;

interface

USES
    UFicheLocation;

TYPE
    {numration des catgories de voitures}
    TEnumCatVoiture = (cvPetite, cvBerline, cvLuxe);

    {classe voiture de location}
    TCVoitureLocation = class
                        {Catgorie du vhicule}
                        catVoiture : TEnumCatVoiture;
                        {nombre de jours de location}
                        nbJours: integer;
                        {nombre de km parcourus}
                        nbKm: double;
                        {gazole ?}
                        carbGazole: boolean;
                        {rcuprer les valeurs  partir de la fiche -- renvoie TRUE si rcupration correcte}
                        function recupValeurs(frm: TFrmPrincipaleLocation): boolean;
                        {calculer le prix de la location}
                        function prixLocation(): double;
                        end;

implementation

USES
    {!! sinon, STRTOFLOAT ne fonctionne pas !!}
    SysUtils;

{ TCVoitureLocation }

function TCVoitureLocation.prixLocation: double;
var dPrix: double;
begin
 //calcul du prix
 case catVoiture of
  cvPetite: dPrix:= 150.0*nbJours+0.5*nbKm;
  cvLuxe: dPrix:= 200.0*nbJours+1.0*nbKm
  {implictement -- berline}
  else dPrix:= 160.0*nbJours+0.6*nbKm;
 end;
 //bonus carburant
 if (carbGazole = TRUE)
  then dPrix:= dPrix*0.9;
 //renvoyer le rsultat
 result:= dPrix;
end;

function TCVoitureLocation.recupValeurs(
  frm: TFrmPrincipaleLocation): boolean;
begin
 {!!!! protger le code !!! avec un gestionnaire d'exceptions}
 TRY
  //rcupration des paramtres -- standard
  nbJours:= strtoint(frm.edJour.Text);
  nbKm:= strtofloat(frm.edKm.Text);
  carbGazole:= frm.chkCarbGazole.Checked;
  //attention, transtypage pour le type de vhicule -- cela vite de faire un CASE OF
  catVoiture:= TEnumCatVoiture(frm.rgCategorie.ItemIndex);
  //c'est ok...
  result:= TRUE;
 EXCEPT
  //un souci est arriv, le signaler
  result:= FALSE;
 END;
end;

end.
